#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

/*
 * Write a single byte at specified file offset.
 * Do not write if value is already set.
 */

void strerror_exit() {
    printf("Error: %s\n", strerror(errno));
    exit(1);
}
 
int main(int argc, char *argv[]) {
    int fd;
    int offset;
    unsigned char buffer;
    unsigned char value;

    if (argc < 4) {
        printf("Usage: %s <device> <offset> <value>\n", argv[0]);
        exit(1);
    }

    offset = atol(argv[2]);
    value = (unsigned char)atoi(argv[3]);

    if ((fd = open(argv[1], O_RDONLY)) == -1) strerror_exit();
    if (lseek(fd, offset, SEEK_SET) == -1) strerror_exit();
    if (read(fd, &buffer, sizeof(buffer)) == -1) strerror_exit();
    if (close(fd) == -1) strerror_exit();
    printf("File \"%s\", offset %u, value %u: ", argv[1], offset, buffer);
    if (buffer == value) {
        printf("value already set\n");
        exit(0);
    }
    printf("writing new value %u\n", value);
    if ((fd = open(argv[1], O_WRONLY | O_EXCL)) == -1) strerror_exit();
    if (lseek(fd, offset, SEEK_SET) == -1) strerror_exit();
    if (write(fd, &value, sizeof(buffer)) == -1) strerror_exit();
    if (close(fd) == -1) strerror_exit();
}
